## s390-tools 1.25.0

=== Makefile ===
ARCH := $(shell uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/)

# Include commond definitions
include common.mak

LIB_DIRS = libvtoc libu2s libutil libzds
SUB_DIRS = $(LIB_DIRS) zipl zdump fdasd dasdfmt dasdview tunedasd \
	   tape390 osasnmpd qetharp ip_watcher qethconf scripts zconf \
	   vmconvert vmcp man mon_tools dasdinfo vmur cpuplugd ipl_tools \
	   ziomon iucvterm hyptop cmsfs-fuse qethqoat zfcpdump zdsfs cpumf \
	   systemd

all: subdirs_make

subdirs_make:
	set -e ; for dir in $(SUB_DIRS) ; do \
		cd $$dir ; $(MAKE) TOPDIR=$(TOPDIR) ARCH=$(ARCH); cd ..; \
	done

clean:
	set -e ; for dir in $(SUB_DIRS) ; do \
		cd $$dir ; $(MAKE) TOPDIR=$(TOPDIR) ARCH=$(ARCH) clean; cd ..; \
	done

install:
	set -e ; for dir in $(SUB_DIRS) ; do \
		cd $$dir ; $(MAKE) TOPDIR=$(TOPDIR) ARCH=$(ARCH) install; cd ..; \
	done

=== cmsfs-fuse/Makefile ===
#!/usr/bin/make -f

include ../common.mak

CPPFLAGS += -I../include

all: cmsfs-fuse

CFLAGS += -D_FILE_OFFSET_BITS=64 -DHAVE_SETXATTR -I/usr/include/fuse
LDLIBS += -lfuse -lpthread -lrt -ldl -lm

OBJECTS = cmsfs-fuse.o dasd.o amap.o config.o
$(OBJECTS): *.h Makefile 

CMSFS_FUSE_DIR = $(SYSCONFDIR)/cmsfs-fuse
CONFIG_FILES = filetypes.conf

cmsfs-fuse: $(OBJECTS) $(rootdir)/libutil/util_list.o

install: all
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 cmsfs-fuse $(USRBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 cmsfs-fuse.1 $(MANDIR)/man1
	$(INSTALL) -g $(GROUP) -o $(OWNER) -d $(CMSFS_FUSE_DIR)
	for cnf in $(CONFIG_FILES); do \
	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 etc/$$cnf $(CMSFS_FUSE_DIR) ; \
	done

clean:
	rm -f cmsfs-fuse *.o

.PHONY: all install clean

=== cpumf/Makefile ===
#!/usr/bin/make -f

include ../common.mak


CPUMF_DATADIR = $(TOOLS_DATADIR)/cpumf
DATA_FILES = cpum-cf-hw-counter.map cpum-cf-generic.ctr \
             cpum-cf-extended-z10.ctr cpum-cf-extended-z196.ctr \
	     cpum-cf-extended-zEC12.ctr cpum-sf-modes.ctr
LIB_FILES = bin/cpumf_helper
USRBIN_SCRIPTS = bin/lscpumf
USRSBIN_SCRIPTS = bin/chcpumf
MAN_FILES = lscpumf.1 chcpumf.8

all:

scripts: $(USRBIN_SCRIPTS) $(USRSBIN_SCRIPTS) $(LIB_FILES)
	chmod +x $(USRBIN_SCRIPTS) $(USRSBIN_SCRIPTS) $(LIB_FILES)

check:

install: scripts install-man
	for prg in $(USRBIN_SCRIPTS); do \
	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 $$prg $(USRBINDIR) ; \
	done
	for prg in $(USRSBIN_SCRIPTS); do \
	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 $$prg $(USRSBINDIR) ; \
	done
	test -d $(CPUMF_DATADIR) || mkdir -p $(CPUMF_DATADIR)
	for lib in $(LIB_FILES); do \
	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 $$lib $(TOOLS_LIBDIR) ; \
	done
	for data in $(DATA_FILES); do \
	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 data/$$data $(CPUMF_DATADIR) ; \
	done

install-man:
	for man in $(MAN_FILES); do \
	  msection=`echo $$man |sed 's/.*\.\([1-9]\)$$/man\1/'` ; \
	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 -D man/$$man $(MANDIR)/$$msection/$$man ; \
	done

man2pdf:
	for man in $(MAN_FILES); do \
	  man -t man/$$man |ps2pdf -sPAPERSIZE=a4 - man/$${man}.pdf ; \
	done
man2text:
	for man in $(MAN_FILES); do \
	  MANWIDTH=80 LANG=C man man/$$man |col -b |expand > man/$${man}.txt ; \
	done

clean:
	rm -f $(LIB_FILES) $(USRBIN_SCRIPTS) $(USRSBIN_SCRIPTS)

%: %.in
	real_sysconf=`echo $(SYSCONFDIR)/iucvterm |sed 's#^$(INSTROOT)##'` ; \
	real_cpumfdir=`echo $(CPUMF_DATADIR) |sed 's#^$(INSTROOT)##'` ; \
	$(SED) -e "s#@sysconf_path@#$$real_sysconf#g" \
	       -e "s#@cpumfdata_path@#$$real_cpumfdir#g" \
	       -e 's#@S390_TOOLS_RELEASE@#$(S390_TOOLS_RELEASE)#g' \
	< $< > $@

.PHONY: all scripts install install-man man2pdf man2text clean

=== cpuplugd/Makefile ===
include ../common.mak

CFLAGS += -I../include

all: cpuplugd

LDLIBS += -lm

OBJECTS = daemon.o cpu.o info.o terms.o config.o main.o getopt.o mem.o
$(OBJECTS): cpuplugd.h

cpuplugd: $(OBJECTS)
	$(LINK) $(LDFLAGS) $^ $(LOADLIBES) $(LDLIBS) -o $@

clean:
	rm -f cpuplugd $(OBJECTS)

install: all
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 cpuplugd $(USRSBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/cpuplugd.8 $(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/cpuplugd.conf.5 \
		$(MANDIR)/man5

.PHONY: all install clean

=== dasdfmt/Makefile ===
include ../common.mak

CPPFLAGS += -I../include

all: dasdfmt

dasdfmt.o: dasdfmt.h ../include/zt_common.h

dasdfmt: dasdfmt.o $(rootdir)/libvtoc/vtoc.o $(rootdir)/libutil/util_proc.o

install: all
	$(INSTALL) -d -m 755 $(BINDIR) $(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 dasdfmt $(BINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 dasdfmt.8  $(MANDIR)/man8 

clean:
	rm -f *.o *~ dasdfmt core

.PHONY: all install clean

=== dasdinfo/Makefile ===
include ../common.mak

CPPFLAGS += -I../include

all: dasdinfo

dasdinfo: dasdinfo.o ../libu2s/u2s.o

install: all
	$(INSTALL) -d -m 755 $(BINDIR) $(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 dasdinfo $(BINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 dasdinfo.8  $(MANDIR)/man8

clean:
	rm -f *.o *~ dasdinfo core

.PHONY: all install clean

=== dasdview/Makefile ===
include ../common.mak

CPPFLAGS += -I../include -DSYSFS
LDLIBS += -lzds
LDFLAGS += -L../libzds

all: dasdview

dasdview.o: dasdview.h ../include/zt_common.h ../include/libzds.h

dasdview: dasdview.o ../libu2s/u2s.o

install: all
	$(INSTALL) -d -m 755 $(BINDIR) $(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 dasdview $(BINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 dasdview.8  $(MANDIR)/man8 

clean:
	rm -f *.o *~ dasdview core

.PHONY: all install clean

=== fdasd/Makefile ===
include ../common.mak

CPPFLAGS += -I../include

all: fdasd

fdasd.o: fdasd.h ../include/zt_common.h

fdasd: fdasd.o $(rootdir)/libvtoc/vtoc.o

install: all
	$(INSTALL) -d -m 755 $(BINDIR) $(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 fdasd $(BINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 fdasd.8  $(MANDIR)/man8 

clean:
	rm -f *.o *~ fdasd core

.PHONY: all install clean

=== hyptop/Makefile ===
include ../common.mak

CPPFLAGS += -I../include

all: hyptop

LDLIBS += -lncurses

OBJECTS = hyptop.o opts.o helper.o \
	  sd_core.o sd_sys_items.o sd_cpu_items.o \
	  tbox.o table.o table_col_unit.o \
	  dg_debugfs.o dg_debugfs_lpar.o dg_debugfs_vm.o \
	  win_sys_list.o win_sys.o win_fields.o \
	  win_cpu_types.o win_help.o nav_desc.o

$(OBJECTS): *.h Makefile

hyptop: $(OBJECTS) $(rootdir)/libutil/util_list.o

install: all
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 hyptop $(USRSBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 hyptop.8  $(MANDIR)/man8

clean:
	rm -f *.o *~ hyptop core

.PHONY: all install clean

=== ip_watcher/Makefile ===
include ../common.mak

CPPFLAGS += -I../include
all: xcec-bridge

xcec-bridge: xcec-bridge.o

clean:
	rm -f *.o core xcec-bridge

install: ip_watcher.pl xcec-bridge start_hsnc.sh
	$(SED) -e 's+%S390_TOOLS_VERSION%+$(S390_TOOLS_RELEASE)+' \
	< start_hsnc.sh >$(USRSBINDIR)/start_hsnc.sh; \
	chown $(OWNER).$(GROUP) $(USRSBINDIR)/start_hsnc.sh; \
	chmod 755 $(USRSBINDIR)/start_hsnc.sh; \
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 ip_watcher.pl $(USRSBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 xcec-bridge $(USRSBINDIR)

.PHONY: all install clean

=== ipl_tools/Makefile ===
include ../common.mak

CPPFLAGS += -I../include

all: chreipl lsreipl chshut lsshut

objects = main.o ccw.o fcp.o system.o shutdown.o \
	  cmd_lsshut.o cmd_chshut.o cmd_lsreipl.o cmd_chreipl.o proc.o
$(objects): ipl_tools.h

chreipl: $(objects)
	$(LINK) $(LDFLAGS) $^ $(LOADLIBES) $(LDLIBS) -o $@

lsreipl:
	ln -sf chreipl lsreipl

chshut:
	ln -sf chreipl chshut

lsshut:
	ln -sf chreipl lsshut

clean:
	rm -f *.o lsreipl chreipl chshut lsshut

install: all
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 chreipl $(USRSBINDIR)
	ln -f -s chreipl $(USRSBINDIR)/lsreipl
	ln -f -s chreipl $(USRSBINDIR)/chshut
	ln -f -s chreipl $(USRSBINDIR)/lsshut
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/chreipl.8 $(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/lsreipl.8 $(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/lsshut.8 $(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/chshut.8 $(MANDIR)/man8

.PHONY: all install clean

=== libutil/Makefile ===
include ../common.mak

CPPFLAGS += -I../include

all: util_list.o util_part.o util_proc.o

util_list.o: util_list.c ../include/util.h

util_proc.o: util_proc.c ../include/util_proc.h

install: all

clean:
	rm -f *.o *~ core

=== debian/changelog ===
s390-tools (1.25.0-2) unstable; urgency=medium

  * Do not build-depend on gcc-4.8 and instead use
    -fno-delete-null-pointer-checks for building zipl's bootloader stage.
    Thanks, Bastian Blank!

 -- Philipp Kern <pkern@debian.org>  Tue, 26 Aug 2014 20:18:31 +0000

s390-tools (1.25.0-1) unstable; urgency=medium

  * New upstream release
    - Refreshed patches.
    - Dropped the backported zipl fix.
    - Build zipl's bootloader part with gcc-4.8 to sidestep miscompilation.
      (Closes: #758115)

 -- Philipp Kern <pkern@debian.org>  Sun, 24 Aug 2014 19:41:12 +0200

s390-tools (1.24.1-1) unstable; urgency=medium

  * New upstream release
    - Refreshed patches.
    - Backported a zipl command-line fix from 1.25.0.

 -- Philipp Kern <pkern@debian.org>  Sun, 10 Aug 2014 22:20:01 +0200

s390-tools (1.17.1-1) unstable; urgency=low

  * New upstream release.
    - Adjusted install.patch.
  * Install udev ruleset as provided by upstream.
    - Add udev-dasd-blkid.patch to use blkid instead of vol_id in
      59-dasd.rules.
    - Do not ship 57-osasnmpd.rules as we do not ship the corresponding
      daemon.

 -- Philipp Kern <pkern@debian.org>  Sat, 04 May 2013 18:39:17 +0000

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

SOURCE  := $(shell dpkg-parsechangelog | sed -ne 's,^Source: *\(.*\)$$,\1,p')
VERSION := $(shell dpkg-parsechangelog | perl -ne '/^Version:\s+(\S+)-[^-]+$$/ && print $$1;')

BUILD_DIR = debian/build
STAMPS_DIR = debian/stamps

setup: $(STAMPS_DIR)/setup

$(STAMPS_DIR)/setup: SOURCE_FILES = $(filter-out debian .svn .svk, $(wildcard * .[^.]*))
$(STAMPS_DIR)/setup: DIR = $(BUILD_DIR)/build
$(STAMPS_DIR)/setup:
	@[ -d $(STAMPS_DIR) ] || mkdir -p $(STAMPS_DIR)
	dh_testdir
	@rm -rf $(DIR)
	QUILT_PATCHES=debian/patches quilt --quiltrc /dev/null push -a || test $$? = 2
	mkdir -p $(DIR)
	cp -a $(SOURCE_FILES) $(DIR)
	touch $@

build: $(STAMPS_DIR)/build

$(STAMPS_DIR)/build: DIR = $(BUILD_DIR)/build
$(STAMPS_DIR)/build: $(STAMPS_DIR)/setup
	dh_testdir
	$(MAKE) -C $(DIR)
	touch $@

clean:
	dh_testdir
	rm -rf $(BUILD_DIR) $(STAMPS_DIR)
	dh_clean

maintainerclean:
	rm -rf $(filter-out .svn debian, $(wildcard * .[^.]*))

install: DIR = $(BUILD_DIR)/build
install: INSTALL_DIR = $(BUILD_DIR)/install
install: $(STAMPS_DIR)/build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	$(MAKE) -C $(DIR) install INSTROOT=$(CURDIR)/$(INSTALL_DIR)

	dh_install --sourcedir=$(INSTALL_DIR)

binary-indep:

binary-arch: install
	dh_testdir -a
	dh_testroot -a
	dh_installchangelogs -a
	dh_installdocs -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
	dh_makeshlibs -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch

DIR_ORIG = ../orig/$(SOURCE)-$(VERSION)
TAR_ORIG_NAME = $(SOURCE)_$(VERSION).orig.tar.bz2
TAR_ORIG = $(firstword $(wildcard ../$(TAR_ORIG_NAME)) $(wildcard ../orig/$(TAR_ORIG_NAME)))

orig: $(DIR_ORIG)
	rsync --delete --exclude debian --exclude .svk --exclude .svn --link-dest=$(DIR_ORIG)/ -a $(DIR_ORIG)/ .

$(DIR_ORIG):
ifeq ($(TAR_ORIG),)
	$(error Cannot find orig tarball $(TAR_ORIG_NAME))
else
	mkdir -p ../orig
	tar -C ../orig -xjf $(TAR_ORIG)
endif

## s390-tools 1.34.0

=== Makefile ===
--- 
+++ 
@@ -3,12 +3,12 @@
 # Include commond definitions
 include common.mak
 
-LIB_DIRS = libvtoc libu2s libutil libzds
+LIB_DIRS = libvtoc libu2s libutil libzds libdasd
 SUB_DIRS = $(LIB_DIRS) zipl zdump fdasd dasdfmt dasdview tunedasd \
 	   tape390 osasnmpd qetharp ip_watcher qethconf scripts zconf \
 	   vmconvert vmcp man mon_tools dasdinfo vmur cpuplugd ipl_tools \
 	   ziomon iucvterm hyptop cmsfs-fuse qethqoat zfcpdump zdsfs cpumf \
-	   systemd
+	   systemd hmcdrvfs cpacfstats zdev
 
 all: subdirs_make

=== cmsfs-fuse/Makefile ===
#!/usr/bin/make -f

include ../common.mak

ifeq (${HAVE_FUSE},0)

all:
	$(SKIP) HAVE_FUSE=0

install:
	$(SKIP) HAVE_FUSE=0

else

check_dep:
	$(call check_dep, \
		"cmsfs-fuse", \
		"fuse.h", \
		"fuse-devel", \
		"HAVE_FUSE=0")

CPPFLAGS += -I../include

all: check_dep cmsfs-fuse

CFLAGS += -D_FILE_OFFSET_BITS=64 -DHAVE_SETXATTR -I/usr/include/fuse
LDLIBS += -lfuse -lm

OBJECTS = cmsfs-fuse.o dasd.o amap.o config.o
$(OBJECTS): *.h Makefile 

CMSFS_FUSE_DIR = $(SYSCONFDIR)/cmsfs-fuse
CONFIG_FILES = filetypes.conf

cmsfs-fuse: $(OBJECTS) $(rootdir)/libutil/util_list.o

install: all
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 cmsfs-fuse \
		$(DESTDIR)$(USRBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 cmsfs-fuse.1 \
		$(DESTDIR)$(MANDIR)/man1
	$(INSTALL) -g $(GROUP) -o $(OWNER) -d $(DESTDIR)$(CMSFS_FUSE_DIR)
	for cnf in $(CONFIG_FILES); do \
	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 etc/$$cnf $(DESTDIR)$(CMSFS_FUSE_DIR) ; \
	done

endif

clean:
	rm -f cmsfs-fuse *.o

.PHONY: all install clean check_dep

=== cpacfstats/Makefile ===
include ../common.mak

CPPFLAGS += -I. -I../include -DVERSION=$(VERSION)


ifeq (${HAVE_PFM},0)

all:
	$(SKIP) HAVE_PFM=0

install:
	$(SKIP) HAVE_PFM=0

else

check_dep:
	$(call check_dep, \
			"cpacfstats", \
			"perfmon/pfmlib.h", \
			"libpfm-devel", \
			"HAVE_PFM=0")

all:		check_dep cpacfstats cpacfstatsd

cpacfstatsd:	cpacfstatsd.o stats_sock.o perf_crypto.o
		$(LINK) $(LDFLAGS) $^ $(LDLIBS) -lpfm -o $@

cpacfstats:	cpacfstats.o stats_sock.o
		$(LINK) $(LDFLAGS) $^ $(LDLIBS) -o $@

install: 	all
		$(INSTALL) -m 755 cpacfstatsd   $(DESTDIR)$(USRSBINDIR)
		$(INSTALL) -m 755 cpacfstats    $(DESTDIR)$(USRBINDIR)
		$(INSTALL) -m 644 cpacfstatsd.8 $(DESTDIR)$(MANDIR)/man8
		$(INSTALL) -m 644 cpacfstats.1  $(DESTDIR)$(MANDIR)/man1

endif
clean:
		rm -f *.o *~ cpacfstatsd cpacfstats

.PHONY: all clean install check_dep

=== cpuplugd/Makefile ===
--- 
+++ 
@@ -16,9 +16,11 @@
 	rm -f cpuplugd $(OBJECTS)
 
 install: all
-	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 cpuplugd $(USRSBINDIR)
-	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/cpuplugd.8 $(MANDIR)/man8
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 cpuplugd \
+		$(DESTDIR)$(USRSBINDIR)
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/cpuplugd.8 \
+		$(DESTDIR)$(MANDIR)/man8
 	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/cpuplugd.conf.5 \
-		$(MANDIR)/man5
+		$(DESTDIR)$(MANDIR)/man5
 
 .PHONY: all install clean

=== dasdfmt/Makefile ===
include ../common.mak

CPPFLAGS += -I../include

all: dasdfmt

dasdfmt.o: dasdfmt.h ../include/zt_common.h

dasdfmt: dasdfmt.o $(rootdir)/libvtoc/vtoc.o $(rootdir)/libutil/util_proc.o \
	$(rootdir)/libdasd/dasd_sys.o $(rootdir)/libu2s/u2s.o

install: all
	$(INSTALL) -d -m 755 $(DESTDIR)$(BINDIR) $(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 dasdfmt $(DESTDIR)$(BINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 dasdfmt.8 \
		$(DESTDIR)$(MANDIR)/man8

clean:
	rm -f *.o *~ dasdfmt core

.PHONY: all install clean

=== dasdinfo/Makefile ===
include ../common.mak

CPPFLAGS += -I../include

all: dasdinfo

dasdinfo: dasdinfo.o ../libu2s/u2s.o

install: all
	$(INSTALL) -d -m 755 $(DESTDIR)$(BINDIR) \
		$(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 dasdinfo $(DESTDIR)$(BINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 dasdinfo.8 \
		$(DESTDIR)$(MANDIR)/man8

clean:
	rm -f *.o *~ dasdinfo core

.PHONY: all install clean

=== dasdview/Makefile ===
include ../common.mak

CPPFLAGS += -I../include -DSYSFS
LDLIBS += -lzds
LDFLAGS += -L../libzds

all: dasdview

dasdview.o: dasdview.h ../include/zt_common.h ../include/libzds.h

dasdview: dasdview.o ../libu2s/u2s.o

install: all
	$(INSTALL) -d -m 755 $(DESTDIR)$(BINDIR) $(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 dasdview $(DESTDIR)$(BINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 dasdview.8 \
		$(DESTDIR)$(MANDIR)/man8

clean:
	rm -f *.o *~ dasdview core

.PHONY: all install clean

=== fdasd/Makefile ===
include ../common.mak

CPPFLAGS += -I../include

all: fdasd

fdasd.o: fdasd.h ../include/zt_common.h

fdasd: fdasd.o $(rootdir)/libvtoc/vtoc.o $(rootdir)/libdasd/dasd_sys.o \
	$(rootdir)/libu2s/u2s.o

install: all
	$(INSTALL) -d -m 755 $(DESTDIR)$(BINDIR) $(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 fdasd $(DESTDIR)$(BINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 fdasd.8 \
		$(DESTDIR)$(MANDIR)/man8

clean:
	rm -f *.o *~ fdasd core

.PHONY: all install clean

=== hmcdrvfs/Makefile ===
#!/usr/bin/make -f

include ../common.mak

ifeq (${HAVE_FUSE},0)

all:
	$(SKIP) HAVE_FUSE=0

install:
	$(SKIP) HAVE_FUSE=0

else

check_dep:
	$(call check_dep, \
		"hmcdrvfs", \
		"fuse.h", \
		"fuse-devel", \
		"HAVE_FUSE=0")

CPPFLAGS += -I../include
CFLAGS += -DFUSE_USE_VERSION=26 -D_GNU_SOURCE -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 -I/usr/include/fuse
LDLIBS += -lfuse -lpthread -lrt -ldl -lm

OBJECTS = hmcdrvfs.o


all: check_dep hmcdrvfs

$(OBJECTS): Makefile

hmcdrvfs: $(OBJECTS)

install: all install-scripts
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 hmcdrvfs \
		$(DESTDIR)$(USRBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 hmcdrvfs.1 \
		$(DESTDIR)$(MANDIR)/man1
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 lshmc.8 \
		$(DESTDIR)$(MANDIR)/man8

install-scripts: lshmc
	@for i in $^; do \
		cat $$i | \
		sed -e 's+%S390_TOOLS_VERSION%+$(S390_TOOLS_RELEASE)+' \
		>$(DESTDIR)$(USRSBINDIR)/$$i; \
		chown $(OWNER).$(GROUP) $(DESTDIR)$(USRSBINDIR)/$$i; \
		chmod 755 $(DESTDIR)$(USRSBINDIR)/$$i; \
	done

endif

clean:
	rm -f hmcdrvfs *.o

.PHONY: all install install-scripts clean check_dep

=== hyptop/Makefile ===
include ../common.mak

ifeq (${HAVE_NCURSES},0)

all:
	$(SKIP) HAVE_NCURSES=0

install:
	$(SKIP) HAVE_NCURSES=0

else

check_dep:
	$(call check_dep, \
		"hyptop", \
		"ncurses.h", \
		"ncurses-devel", \
		"HAVE_NCURSES=0")

CPPFLAGS += -I../include

all: check_dep hyptop

LDLIBS += -lncurses

OBJECTS = hyptop.o opts.o helper.o \
	  sd_core.o sd_sys_items.o sd_cpu_items.o \
	  tbox.o table.o table_col_unit.o \
	  dg_debugfs.o dg_debugfs_lpar.o dg_debugfs_vm.o dg_debugfs_vmd0c.o \
	  win_sys_list.o win_sys.o win_fields.o \
	  win_cpu_types.o win_help.o nav_desc.o

$(OBJECTS): *.h Makefile

hyptop: $(OBJECTS) $(rootdir)/libutil/util_list.o

install: all
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 hyptop \
		$(DESTDIR)$(USRSBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 hyptop.8 \
		$(DESTDIR)$(MANDIR)/man8

endif

clean:
	rm -f *.o *~ hyptop core

.PHONY: all install clean check_dep

=== ip_watcher/Makefile ===
include ../common.mak

CPPFLAGS += -I../include
all: xcec-bridge

xcec-bridge: xcec-bridge.o

clean:
	rm -f *.o core xcec-bridge

install: ip_watcher.pl xcec-bridge start_hsnc.sh
	$(SED) -e 's+%S390_TOOLS_VERSION%+$(S390_TOOLS_RELEASE)+' \
	< start_hsnc.sh >$(DESTDIR)$(USRSBINDIR)/start_hsnc.sh; \
	chown $(OWNER).$(GROUP) $(DESTDIR)$(USRSBINDIR)/start_hsnc.sh; \
	chmod 755 $(DESTDIR)$(USRSBINDIR)/start_hsnc.sh; \
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 ip_watcher.pl \
		$(DESTDIR)$(USRSBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 xcec-bridge \
		$(DESTDIR)$(USRSBINDIR)

.PHONY: all install clean

=== ipl_tools/Makefile ===
include ../common.mak

CPPFLAGS += -I../include

all: chreipl lsreipl chshut lsshut

objects = main.o ccw.o fcp.o system.o shutdown.o \
	  cmd_lsshut.o cmd_chshut.o cmd_lsreipl.o cmd_chreipl.o proc.o
$(objects): ipl_tools.h

chreipl: $(objects)
	$(LINK) $(LDFLAGS) $^ $(LOADLIBES) $(LDLIBS) -o $@

lsreipl:
	ln -sf chreipl lsreipl

chshut:
	ln -sf chreipl chshut

lsshut:
	ln -sf chreipl lsshut

clean:
	rm -f *.o lsreipl chreipl chshut lsshut

install: all
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 chreipl \
		$(DESTDIR)$(USRSBINDIR)
	ln -f -s chreipl $(DESTDIR)$(USRSBINDIR)/lsreipl
	ln -f -s chreipl $(DESTDIR)$(USRSBINDIR)/chshut
	ln -f -s chreipl $(DESTDIR)$(USRSBINDIR)/lsshut
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/chreipl.8 \
		$(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/lsreipl.8 \
		$(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/lsshut.8 \
		$(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/chshut.8 \
		$(DESTDIR)$(MANDIR)/man8

.PHONY: all install clean

=== debian/changelog ===
s390-tools (1.34.0-0ubuntu8.7) xenial; urgency=low

  * No-change rebuild against the -security pocket to let this be
    copied out to -security as the kernels it supports are destined
    to go to -security at some point.

 -- Andy Whitcroft <apw@canonical.com>  Wed, 02 May 2018 15:22:13 +0100

s390-tools (1.34.0-0ubuntu8.6) xenial; urgency=medium

  * zz-zipl: Do not run if non-optional initrds don't exist yet (LP: #1766727)
    - Backport of the fix for bionic by Adam Conrad.

 -- Thadeu Lima de Souza Cascardo <cascardo@canonical.com>  Mon, 30 Apr 2018 11:20:25 -0300

s390-tools (1.34.0-0ubuntu8.5) xenial; urgency=medium

  * Correct postinst, which cleans up erroneous directory from
    1.34.0-0ubuntu8 upload and earlier. LP: #1608927

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 21 Feb 2018 16:44:02 +0000

s390-tools (1.34.0-0ubuntu8.4) xenial; urgency=medium

  * chzdev: Fix ineffective zfcp-lun udev rule preventing activation of
    unordered WWPNs. LP: #1683808

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 06 Jul 2017 14:14:51 +0100

s390-tools (1.34.0-0ubuntu8.2) xenial; urgency=medium

  * zipl: Import off-by-one patch to resolve failure to start subchannel
    in FBA loader. LP: #1592990.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 28 Jun 2016 10:51:39 +0100

s390-tools (1.34.0-0ubuntu8.1) xenial; urgency=medium

  * Fix ts-shell maintainer scripts LP: #1567473:
    - create /var/log/ts-shell directory with the right permissions
    - remove errorous directory
  * Install iuctty-login@.service systemd unit, with a correct path LP:
    #1580226
  * Cherrypick upstream fix for buffer overflow in dasdfmt. LP: #1582728

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 06 Jun 2016 11:51:16 +0100

s390-tools (1.34.0-0ubuntu8) xenial; urgency=medium

  * Ship dumpconf legacy init script, and sysconfig file. LP: #1564690
  * Integrate ts-shell. LP: #1567473
  * Recommend statd package, and mention it by mon_statd name too to aid
    discovery.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 14 Apr 2016 14:26:16 +0100

s390-tools (1.34.0-0ubuntu7) xenial; urgency=medium

  * Add statd subpackage with modules-load.d snippet and
    mon_fstatd/mon_procd units to enable statd daemons. LP: #1569454.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 13 Apr 2016 13:51:49 +0100

s390-tools (1.34.0-0ubuntu6) xenial; urgency=medium

  * Drop more obsolete WAIT_FOR udev rules stanzas.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 12 Apr 2016 12:36:06 +0100

s390-tools (1.34.0-0ubuntu5) xenial; urgency=medium

  * Add condition to cpacfstatsd.service to only start on LPARs (which may
    still fail, if LPAR is not configured with the right counters).
  * Add a system group for cpacfstatsd.service.
  * Reluctantly Bump crashkernel to 196M, as otherwise 128M is not enough
    by default to collect a kdump on any LPAR, defeating the intended
    purpose in the first place. (LP: #1564475)

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 11 Apr 2016 12:51:36 +0100

s390-tools (1.34.0-0ubuntu4) xenial; urgency=medium

  * Inlcude chzdev & lzdev utilities in the udeb.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 08 Apr 2016 11:55:01 +0100

s390-tools (1.34.0-0ubuntu3) xenial; urgency=medium

  * Ship all tools, mostly harmless LP: #1555167, LP: #1564690, LP: #1564696
  * Add snmp build-dependency to build osasnmpd as a separate
    package LP: #1564699
  * Add cpuplugd, with patches to default config, as a separate
    package LP: #1564496
  * Update branding from "S/390" to "z Systems"

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 06 Apr 2016 02:12:04 +0100

s390-tools (1.34.0-0ubuntu2) xenial; urgency=medium

  * Upgrade /etc/zipl.conf to include crashkernel parameter by default
    (LP: #1555159)

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 18 Mar 2016 17:58:20 +0000

s390-tools (1.34.0-0ubuntu1) xenial; urgency=medium

  [ Dimitri John Ledkov ]
  * New upstream release LP: #1558274. LP: #1559188.

  [ Hendrik Brueckner ]
  * Added missing lsscm command to display Storage-Class Memory,
    aka. Flash Express  (Closes: #818381) LP: #1558273
  * Added tools to display information about the CPU-measurement counter
    and sampling facilities.  This includes a database with hardware
    counter information.  (Closes: #818385) LP: #1558277
  * Added zdsfs and hmc drive FUSE file systems (Closes: #818495) LP: #1558709

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 18 Mar 2016 17:20:08 +0000

s390-tools (1.33.0-1ubuntu2) xenial; urgency=medium

  * Include debian ifupdown networking information. LP: #1551819

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 16 Mar 2016 12:14:51 +0000

s390-tools (1.33.0-1ubuntu1) xenial; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Add zfcp monitoring and reporting tools (ziomon).
    - ship dbginfo.sh
    - fix bashism in dbginfo
    - ship chzdev and lszdev tools

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 07 Mar 2016 11:57:02 +0000

s390-tools (1.33.0-1) unstable; urgency=medium

  [ Philipp Kern ]
  * New upstream release.
  * Make the build verbose.

  [ Hendrik Brueckner ]
  * Clean up lsluns comment leftovers.
  * Install additional management utilities: lschp, chchp, dasdstat,
    cio_ignore, and znetconf with its related files. (Closes: #812092)

 -- Philipp Kern <pkern@debian.org>  Sun, 14 Feb 2016 13:53:07 +0100

s390-tools (1.33.0-0ubuntu2) xenial; urgency=medium

  [ Hendrik Brueckner ]
  * Add zfcp monitoring and reporting tools (ziomon) (Closes: #812588)
    LP: #1540425.

  [ Dimitri John Ledkov ]
  * Drop dependencies/recommendencies for ziomon to Suggests, to avoid
    pulling those large packages, on all installation types (including
    virtual machines, cloud images, lxc/lxd/docker containers)

  * Possibly it is time to split s390-tools into essential, and optional
    binary packages with correct dependencies.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 09 Feb 2016 11:38:46 +0000



=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

options= V=1 HAVE_SNMP=1 SYSTEMDSYSTEMUNITDIR=/lib/systemd/system

%:
	dh $@ --parallel --with systemd

override_dh_install:
	# no dracut
	rm debian/tmp/lib/s390-tools/zdev-root-update
	cp etc/sysconfig/cpuplugd debian/tmp/etc/cpuplugd.conf
	chmod -x debian/tmp/etc/*/*.conf debian/tmp/lib/s390-tools/zfcpdump/zfcpdump_part.rd
	dh_install -ps390-tools-cpuplugd
	dh_install -ps390-tools-statd
	dh_install -ps390-tools-osasnmpd
	dh_install -Xcpuplugd -Xosasnmpd -Xprocd -Xfsstatd --fail-missing

override_dh_auto_clean:
	dh_auto_clean -- $(options)

override_dh_auto_build:
	dh_auto_build -- $(options)

override_dh_auto_install:
	dh_auto_install -- $(options)

## s390-tools 1.36.1

=== Makefile ===
ARCH := $(shell uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/)

# Include common definitions
include common.mak

LIB_DIRS = libvtoc libu2s libutil libzds libdasd libvmdump
TOOL_DIRS = zipl zdump fdasd dasdfmt dasdview tunedasd \
	   tape390 osasnmpd qetharp ip_watcher qethconf scripts zconf \
	   vmconvert vmcp man mon_tools dasdinfo vmur cpuplugd ipl_tools \
	   ziomon iucvterm hyptop cmsfs-fuse qethqoat zfcpdump zdsfs cpumf \
	   systemd hmcdrvfs cpacfstats zdev
SUB_DIRS = $(LIB_DIRS) $(TOOL_DIRS)

all: $(TOOL_DIRS)
clean: $(TOOL_DIRS)
install: $(TOOL_DIRS)

#
# For simple "make" we explicitly set the MAKECMDGOALS to "all".
#
ifeq ($(MAKECMDGOALS),)
MAKECMDGOALS = all
endif

#
# We have to build the libraries before the tools are built. Otherwise
# the tools would trigger parallel "make -C" builds for libraries in
# case of "make -j".
#
# MAKECMDGOALS contains the list of goals, e.g. "clean all". We use
# "foreach" to generate a ";" separated list of "make -C <target>".
# For example the the expansion for "make clean all" is:
#
# $(MAKE) -C $@ [..] clean ;  $(MAKE) -C $@ [...] all ;
#
# This ensures that the commandline targets are serialized and also "make -j"
# works as expected, e.g. "make clean all -j 20".
#

$(TOOL_DIRS): $(LIB_DIRS)
	$(foreach goal,$(MAKECMDGOALS), \
		$(MAKE) -C $@ TOPDIR=$(TOPDIR) ARCH=$(ARCH) $(goal) ;)
.PHONY: $(TOOL_DIRS)

$(LIB_DIRS):
	$(foreach goal,$(MAKECMDGOALS), \
		$(MAKE) -C $@ TOPDIR=$(TOPDIR) ARCH=$(ARCH) $(goal) ;)
.PHONY: $(LIB_DIRS)

=== cmsfs-fuse/Makefile ===
--- 
+++ 
@@ -19,12 +19,19 @@
 		"fuse-devel", \
 		"HAVE_FUSE=0")
 
-CPPFLAGS += -I../include
+ALL_CPPFLAGS += -I../include
 
 all: check_dep cmsfs-fuse
 
-CFLAGS += -D_FILE_OFFSET_BITS=64 -DHAVE_SETXATTR -I/usr/include/fuse
-LDLIBS += -lfuse -lm
+ifneq ($(shell sh -c 'command -v pkg-config'),)
+FUSE_CFLAGS = $(shell pkg-config --silence-errors --cflags fuse)
+FUSE_LDLIBS = $(shell pkg-config --silence-errors --libs fuse)
+else
+FUSE_CFLAGS = -D_FILE_OFFSET_BITS=64 -I/usr/include/fuse
+FUSE_LDLIBS = -lfuse
+endif
+ALL_CFLAGS += -DHAVE_SETXATTR $(FUSE_CFLAGS)
+LDLIBS += $(FUSE_LDLIBS) -lm
 
 OBJECTS = cmsfs-fuse.o dasd.o amap.o config.o
 $(OBJECTS): *.h Makefile 
@@ -32,7 +39,9 @@
 CMSFS_FUSE_DIR = $(SYSCONFDIR)/cmsfs-fuse
 CONFIG_FILES = filetypes.conf
 
-cmsfs-fuse: $(OBJECTS) $(rootdir)/libutil/util_list.o
+libs = $(rootdir)/libutil/libutil.a
+
+cmsfs-fuse: $(OBJECTS) $(libs)
 
 install: all
 	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 cmsfs-fuse \

=== cpacfstats/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 include ../common.mak
 
-CPPFLAGS += -I. -I../include -DVERSION=$(VERSION)
+ALL_CPPFLAGS += -I. -I../include -DVERSION=$(VERSION)
 
 
 ifeq (${HAVE_PFM},0)
@@ -23,10 +23,10 @@
 all:		check_dep cpacfstats cpacfstatsd
 
 cpacfstatsd:	cpacfstatsd.o stats_sock.o perf_crypto.o
-		$(LINK) $(LDFLAGS) $^ $(LDLIBS) -lpfm -o $@
+		$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -lpfm -o $@
 
 cpacfstats:	cpacfstats.o stats_sock.o
-		$(LINK) $(LDFLAGS) $^ $(LDLIBS) -o $@
+		$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -o $@
 
 install: 	all
 		$(INSTALL) -m 755 cpacfstatsd   $(DESTDIR)$(USRSBINDIR)

=== cpumf/Makefile ===
--- 
+++ 
@@ -21,23 +21,23 @@
 
 install: scripts install-man
 	for prg in $(USRBIN_SCRIPTS); do \
-	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 $$prg $(USRBINDIR) ; \
+	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 $$prg $(DESTDIR)$(USRBINDIR) ; \
 	done
 	for prg in $(USRSBIN_SCRIPTS); do \
-	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 $$prg $(USRSBINDIR) ; \
+	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 $$prg $(DESTDIR)$(USRSBINDIR) ; \
 	done
-	test -d $(CPUMF_DATADIR) || mkdir -p $(CPUMF_DATADIR)
+	test -d $(DESTDIR)$(CPUMF_DATADIR) || mkdir -p $(DESTDIR)$(CPUMF_DATADIR)
 	for lib in $(LIB_FILES); do \
-	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 $$lib $(TOOLS_LIBDIR) ; \
+	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 $$lib $(DESTDIR)$(TOOLS_LIBDIR) ; \
 	done
 	for data in $(DATA_FILES); do \
-	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 data/$$data $(CPUMF_DATADIR) ; \
+	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 data/$$data $(DESTDIR)$(CPUMF_DATADIR) ; \
 	done
 
 install-man:
 	for man in $(MAN_FILES); do \
 	  msection=`echo $$man |sed 's/.*\.\([1-9]\)$$/man\1/'` ; \
-	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 -D man/$$man $(MANDIR)/$$msection/$$man ; \
+	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 -D man/$$man $(DESTDIR)$(MANDIR)/$$msection/$$man ; \
 	done
 
 man2pdf:
@@ -53,10 +53,10 @@
 	rm -f $(LIB_FILES) $(USRBIN_SCRIPTS) $(USRSBIN_SCRIPTS)
 
 %: %.in
-	real_sysconf=`echo $(SYSCONFDIR)/iucvterm |sed 's#^$(INSTROOT)##'` ; \
-	real_cpumfdir=`echo $(CPUMF_DATADIR) |sed 's#^$(INSTROOT)##'` ; \
-	$(SED) -e "s#@sysconf_path@#$$real_sysconf#g" \
-	       -e "s#@cpumfdata_path@#$$real_cpumfdir#g" \
+	real_libdir=$(TOOLS_LIBDIR); \
+	real_cpumfdatadir=$(CPUMF_DATADIR); \
+	$(SED) -e "s#@lib_path@#$$real_libdir#g" \
+	       -e "s#@cpumfdata_path@#$$real_cpumfdatadir#g" \
 	       -e 's#@S390_TOOLS_RELEASE@#$(S390_TOOLS_RELEASE)#g' \
 	< $< > $@

=== cpuplugd/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 include ../common.mak
 
-CFLAGS += -I../include
+ALL_CFLAGS += -I../include
 
 all: cpuplugd
 
@@ -10,7 +10,7 @@
 $(OBJECTS): cpuplugd.h
 
 cpuplugd: $(OBJECTS)
-	$(LINK) $(LDFLAGS) $^ $(LOADLIBES) $(LDLIBS) -o $@
+	$(LINK) $(ALL_LDFLAGS) $^ $(LOADLIBES) $(LDLIBS) -o $@
 
 clean:
 	rm -f cpuplugd $(OBJECTS)

=== dasdfmt/Makefile ===
--- 
+++ 
@@ -1,13 +1,17 @@
 include ../common.mak
 
-CPPFLAGS += -I../include
+ALL_CPPFLAGS += -I../include
 
 all: dasdfmt
 
+libs =	$(rootdir)/libdasd/libdasd.a \
+	$(rootdir)/libvtoc/libvtoc.a \
+	$(rootdir)/libu2s/libu2s.a \
+	$(rootdir)/libutil/libutil.a
+
 dasdfmt.o: dasdfmt.h ../include/zt_common.h
 
-dasdfmt: dasdfmt.o $(rootdir)/libvtoc/vtoc.o $(rootdir)/libutil/util_proc.o \
-	$(rootdir)/libdasd/dasd_sys.o $(rootdir)/libu2s/u2s.o
+dasdfmt: dasdfmt.o $(libs)
 
 install: all
 	$(INSTALL) -d -m 755 $(DESTDIR)$(BINDIR) $(DESTDIR)$(MANDIR)/man8

=== dasdinfo/Makefile ===
--- 
+++ 
@@ -1,10 +1,12 @@
 include ../common.mak
 
-CPPFLAGS += -I../include
+ALL_CPPFLAGS += -I../include
+
+libs = $(rootdir)/libu2s/libu2s.a
 
 all: dasdinfo
 
-dasdinfo: dasdinfo.o ../libu2s/u2s.o
+dasdinfo: dasdinfo.o $(libs)
 
 install: all
 	$(INSTALL) -d -m 755 $(DESTDIR)$(BINDIR) \

=== dasdview/Makefile ===
--- 
+++ 
@@ -1,14 +1,18 @@
 include ../common.mak
 
-CPPFLAGS += -I../include -DSYSFS
-LDLIBS += -lzds
-LDFLAGS += -L../libzds
+ALL_CPPFLAGS += -I../include -DSYSFS
 
 all: dasdview
 
+libs =	$(rootdir)/libdasd/libdasd.a \
+	$(rootdir)/libvtoc/libvtoc.a \
+	$(rootdir)/libu2s/libu2s.a \
+	$(rootdir)/libzds/libzds.a \
+	$(rootdir)/libutil/libutil.a
+
 dasdview.o: dasdview.h ../include/zt_common.h ../include/libzds.h
 
-dasdview: dasdview.o ../libu2s/u2s.o
+dasdview: dasdview.o $(libs)
 
 install: all
 	$(INSTALL) -d -m 755 $(DESTDIR)$(BINDIR) $(DESTDIR)$(MANDIR)/man8

=== fdasd/Makefile ===
--- 
+++ 
@@ -1,13 +1,17 @@
 include ../common.mak
 
-CPPFLAGS += -I../include
+ALL_CPPFLAGS += -I../include
+
+libs =	$(rootdir)/libvtoc/libvtoc.a \
+	$(rootdir)/libzds/libzds.a \
+	$(rootdir)/libdasd/libdasd.a \
+	$(rootdir)/libu2s/libu2s.a
 
 all: fdasd
 
 fdasd.o: fdasd.h ../include/zt_common.h
 
-fdasd: fdasd.o $(rootdir)/libvtoc/vtoc.o $(rootdir)/libdasd/dasd_sys.o \
-	$(rootdir)/libu2s/u2s.o
+fdasd: fdasd.o $(libs)
 
 install: all
 	$(INSTALL) -d -m 755 $(DESTDIR)$(BINDIR) $(DESTDIR)$(MANDIR)/man8

=== hmcdrvfs/Makefile ===
--- 
+++ 
@@ -19,9 +19,16 @@
 		"fuse-devel", \
 		"HAVE_FUSE=0")
 
-CPPFLAGS += -I../include
-CFLAGS += -DFUSE_USE_VERSION=26 -D_GNU_SOURCE -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 -I/usr/include/fuse
-LDLIBS += -lfuse -lpthread -lrt -ldl -lm
+ifneq ($(shell sh -c 'command -v pkg-config'),)
+FUSE_CFLAGS = $(shell pkg-config --silence-errors --cflags fuse)
+FUSE_LDLIBS = $(shell pkg-config --silence-errors --libs fuse)
+else
+FUSE_CFLAGS = -D_FILE_OFFSET_BITS=64 -I/usr/include/fuse
+FUSE_LDLIBS = -lfuse
+endif
+ALL_CPPFLAGS += -I../include
+ALL_CFLAGS += -DFUSE_USE_VERSION=26 -D_GNU_SOURCE -D_LARGEFILE_SOURCE $(FUSE_CFLAGS)
+LDLIBS += $(FUSE_LDLIBS) -lpthread -lrt -ldl -lm
 
 OBJECTS = hmcdrvfs.o

=== hyptop/Makefile ===
--- 
+++ 
@@ -17,7 +17,7 @@
 		"ncurses-devel", \
 		"HAVE_NCURSES=0")
 
-CPPFLAGS += -I../include
+ALL_CPPFLAGS += -I../include
 
 all: check_dep hyptop
 
@@ -32,7 +32,7 @@
 
 $(OBJECTS): *.h Makefile
 
-hyptop: $(OBJECTS) $(rootdir)/libutil/util_list.o
+hyptop: $(OBJECTS) $(rootdir)/libutil/libutil.a
 
 install: all
 	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 hyptop \

=== ip_watcher/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 include ../common.mak
 
-CPPFLAGS += -I../include
+ALL_CPPFLAGS += -I../include
 all: xcec-bridge
 
 xcec-bridge: xcec-bridge.o

=== debian/changelog ===
s390-tools (1.36.1-1) unstable; urgency=medium

  * New upstream release
  * Build/link zipl with -fno-pie/-no-pie, as PIE is now enabled globally in
    Debian's build of gcc and zipl will halt at boot if it is enabled.
  * Drop the CFLAGS/CXXFLAGS patches, as the upstream build system now
    allows one to pass in custom environment variables without overwriting
    them.

 -- Philipp Kern <pkern@debian.org>  Tue, 24 Jan 2017 03:29:35 -0500

s390-tools (1.34.0-2) unstable; urgency=medium

  [ Hendrik Brueckner ]
  * Added zdsfs and hmc drive FUSE file systems (Closes: #818495)
  * Added tools to display information about the CPU-measurement counter
    and sampling facilities.  This includes a database with hardware
    counter information. (Closes: #818385)
  * Added lsscm command to display Storage-Class Memory aka Flash Express
    (Closes: #818381)

  [ Philipp Kern ]
  * Use dh instead of raw debhelper commands.
  * Let the build system not overwrite CFLAGS/CXXFLAGS but append to it.
  * Bump debhelper compatibility level from 7 to 9.
  * Dropped the leading article from the description synopsis.
  * Added copyright notices to debian/copyright.

 -- Philipp Kern <pkern@debian.org>  Sun, 03 Apr 2016 11:53:35 +0200

s390-tools (1.34.0-1) unstable; urgency=medium

  * New upstream release.
    - Drop error-manpages.patch (fixed upstream).
    - Drop install.patch (works as-is with upstream's build system).

 -- Philipp Kern <pkern@debian.org>  Sun, 20 Mar 2016 22:54:33 +0100

=== debian/control ===
Source: s390-tools
Section: admin
Priority: important
Maintainer: Debian S/390 Team <debian-s390@lists.debian.org>
Uploaders: Bastian Blank <waldi@debian.org>, Philipp Kern <pkern@debian.org>
Build-Depends: debhelper (>> 9), libsysfs-dev, libz-dev, quilt, gcc-multilib, libfuse-dev, libncurses-dev, libpfm4-dev
Standards-Version: 3.8.3
Homepage: http://www.ibm.com/developerworks/linux/linux390/s390-tools.html

Package: s390-tools
Architecture: s390 s390x
Depends: ${shlibs:Depends}, ${misc:Depends}, gawk
Recommends: sg3-utils
Description: Set of fundamental utilities for Linux on S/390
 The package contains:
  * dasdfmt, which is used to low-level format ECKD-DASDs with either
    the classic disk layout or the new zSeries compatible disk layout.
  * dasdview, which is used to display DASD and VTOC information or to
    dump the contents of a DASD to the console.
  * fdasd, which is used to create or modify partitions on ECKD-DASDs
    formatted with the zSeries compatible disk layout.
  * zipl, which is used to make either dasds or tapes bootable for
    system IPL or system dump.
  * zgetdump, which is used to retrieve system dumps from either tapes
    or dasds.

Package: s390-tools-udeb
XC-Package-Type: udeb
Section: debian-installer
Priority: optional
Architecture: s390 s390x
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Set of utilities for Linux on S/390
 This is a minimal package used by debian-installer.
 This package contains only the binaries dasdfmt and fdasd.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_build:
	make V=1

override_dh_auto_install:
	make install DESTDIR=$(CURDIR)/debian/tmp
	dh_install
